# Whoison 2.0
#
# This little script is based on quesedilla v3 by Robey Pointer
# Personally i like the original but in times like these where bots 
# arent liked very much by IRCops (mine was k-lined on one server after 
# 5 days) and takeovers are a kind of sport, it should be possible to 
# 'hide' some information. I can imagine that IRCops like pages where they
# just have to look at and see who's a bot :))). Or infolines on a page,
# tell everybody who is known by the bot and hostaddress spoofing is quite
# easy 2day. I know i sound a bit paranoid and maybe i am but u know the 
# saying: once bitten, twice shy :)))
#
# Have fun wih the script 
#			DaMista
#
#-----------------------------------------------------------------------------
#
# quesedilla v3, by robey (the basic script)
# 
# 05.11.1997 - removed lynx-support (think it's no longer needed)
# 06.11.1997 - had to change some names as by bot screwed up while running
#              quesdilla and whoison at the same time...who wonders :)
#              wanted to sort the output but it's not yet satisfying and 
#              tcl 7.4 doesn't support the '-dictionary' sortorder
#              so u have to stick with the weird sortorder atm
# 07.11.1997   made the output more various and suppressable
#
# 19.11.1997   the script can now generate files with different BODY tags
#     	       the handling changed a bit but if you follow the examples
#	       everything should work out fine. i had to change the handling
#              because i need two different looking pages of the same channel
#              (to make them fit into the general site look and feel). 
#
#
#


## this line makes sure other scripts won't interfere
catch {unset webpage}

## for each webpage you want, do this:
set webpage(mychannel.html) "#MyChannel"
set webpage(mychannel2.html) "#MyChannel"
set webpage(another.html) "#AnotherChannel"

## give the filepath for each page you want to have (please don't forget the '/')
set webpathname(mychannel.html) "/u/home/mybot/htdocs/"
set webpathname(mychanne2.html) "/u/home/mybot/htdocs/"
set webpathname(another.html) "/u/home/mybot/htdocs/"

## for each webpage, you can store a different BODY tag. so u can have 
## achieve a different look for each page.
set bodytag(mychannel.html) "<body text=\"#FFFFff\" bgcolor=\"#000000\" link=\"#ffffff\" vlink=\"#ffffff\" alink=\"#FF0000\">"
set bodytag(mychannel2.html) "<body text=\"#FFFF00\" bgcolor=\"#000000\" link=\"#00FF00\" vlink=\"#008000\" alink=\"#FF0000\">"
set bodytag(another.html) "<body background=\"space.jpg\" text=\"#FFFF00\" bgcolor=\"#000000\" link=\"#00FF00\" vlink=\"#008000\" alink=\"#FF0000\">"


## which chatnet is the bot on?
set chatnet "IRCnet"

## how often should these html files get updated?
## (1 means once every minute, 5 means once every 5 minutes, etc)
set web_update 1

## this will help people figure out what timezone you're in :)
set webtz "CET"

## this will determine if bots are shown as such or not 
## this might be interesting to hide the bots. 
## (0 means show them as users, 1 means show them as bots)
set show_bots 0

## this will determine if the info line of known users will be displayed
## (0 means don't display, 1 means display it)
set show_info 1

## this will determine whether a users url is shown on page (if available)
## if the url is stored in the info field, it will be displayed, no matter
## whether the show_info is set to true or false
set show_url 1


proc makepage {} {
  global webpage web_update botnick webtz show_bots show_info show_url chatnet 
  global bodytag webpathname
  foreach pagename [array names webpage] {

    set filename "$webpathname($pagename)${pagename}"
    set fd [open $filename w]     
    set chan $webpage($pagename)
    puts $fd "<html>"
    puts $fd "<head>"
    puts $fd "<title>People on $chan ($chatnet) right now</title>"
    puts $fd "<meta http-equiv=\"Refresh\" content=[expr $web_update *60]>"
    puts $fd "<meta NAME=\"Author\" CONTENT=\"generated by Whoison v1.0\">"
    puts $fd "<meta name=\"keywords\" content=\"irc, chat, $chan \">"
    puts $fd "</head>"
    puts $fd $bodytag($pagename)
    puts $fd "<center><h1>$chan ($chatnet)</h1>"
    puts $fd "<table border=1 cellpadding=4>"
    puts $fd "<caption>People on $chan as of [date] [time] $webtz</caption>"
    puts $fd "<th align=left>Nickname<th align=left>Status"
    puts $fd "<th align=left>User@Host"
    foreach i [lsort [chanlist $chan]] {
      puts $fd "<tr>"
      if {[isop $i $chan]} { set chop "op"} { set chop "" }
      if {[getchanidle $i $chan] > 10} {
        if {$chop == ""} { set chop "idle" } { set chop "${chop}, idle" }
      }
      set handle [finduser $i![getchanhost $i $chan]]
      if {[onchansplit $i $chan]} {
        if {$chop == ""} { 
          set chop "<strong>(split)</strong>"
        } {
          set chop "${chop} <strong>(split)</strong>"
        }
      }
      set url [user-get $handle url]
      set info [getinfo $handle]
      set comment [getcomment $handle]
      if {"" == $chop} { set chop "-" }
      set link ""
      set urllink ""
      if {"" != $url} {
        set urllink "<a href=\"$url\" target=\"_top\">$url</a>"
      }
      if {("" == $urllink) && 
          ([string compare [string range $comment 0 6] "http://"] == 0)} {
        set urllink "<a href=\"[lindex [split $comment] 0]\"target=\"_top\">$comment</a>"
      }
      if {("" == $urllink) &&
          ([string compare [string range $info 0 6] "http://"] == 0)} {
        set urllink "<a href=\"[lindex [split $info] 0]\"target=\"_top\">$info</a>"
      }
      set email [getemail $handle]
      if {("" != $email) && ([string first @ $email] > 0)} {
        set link "<a href=\"mailto:$email\">"
      }
      if {"" != $link} { set elink "</a>" } { set elink "" }
      puts $fd "<td align=left>${link}${i}${elink}</td>"
      puts $fd "<td align=left>${chop}</td>"
      set chost [getchanhost $i $chan]
      if {[string compare [string tolower $i] [string tolower $botnick]] == 0} {
        if {$show_bots} {
          set chost "<em>This is me, the channel bot.</em>"
          set info ""
        } 
      } {
        if {[matchattr $handle b]} {
          if {$show_bots} {
            set chost "<em>This is another channel bot.</em>"
            set info ""
          }
        } 
      }
      puts $fd "<td align=left>${chost}</td>"
      if {$show_info} {
        if {"" != $info} {
          puts $fd "<tr><td></td><td colspan=2><strong>Info:</strong> $info</td>"
        }
      }
      if {$show_url} {
        if {"" != $urllink} {
          puts $fd "<tr><td></td><td colspan=2><strong>Url:</strong> $urllink</td>"
        }
      }
    }
    puts $fd "</table></center>"
    puts $fd "<p><hr><address>Created by Whoison v2.0"
    puts $fd "<address>This page is automatically refreshed.</address>"
    puts $fd "</body>"
    puts $fd "</html>"
    close $fd
  }
  timer $web_update makepage
}

if {![info exists running]} {
  timer $web_update makepage
  set running 1
}
set xxchans ""
foreach i [array names webpage] {
  set xxchans "$xxchans $i"
  set xxchans "${xxchans},"
}
set xxchans [string trimright $xxchans ","]
putlog "Whoison v2.0 (19.11.1997) by DaMista:$xxchans"
unset xxchans
